QGIS Application - Bug report #5335
"export/add geometry columns" make QGIS crash if you have previously opened the attribute table
2012-04-09 07:38 AM - Giovanni Manghi

Status: Closed
Priority: High
Assignee: Alexander Bruy
Category: Processing/QGIS
Affected QGIS version:master Regression?:
Operating System: Easy fix?:
Pull Request or Patch supplied: Resolution: fixed
Crashes QGIS or corruptsdata: Copied to github as #: 15036
Description
ggio@sibirica:~$ qgis

Warning: loading of qgis translation failed [/usr/share/qgis/i18n//qgis_en_US]
Warning: loading of gt translation failed [/usr/share/qt4/translations/qt_en_US]
Warning: QHttp: empty path requested is invalid -- using '/'

Warning: QObject::setParent: Cannot set parent, new parent is in a different thread
Warning: QPixmap: It is not safe to use pixmaps outside the GUI thread

Warning: QPixmap: It is not safe to use pixmaps outside the GUI thread

Xlib: sequence lost (0x1970f > 0x9717) in reply type Ox1ic!

[xcb] Unknown request in queue while dequeuing

[xcb] Most likely this is a multi-threaded client and XInitThreads has not been called
[xcb] Aborting, sorry about that.

qgis.bin: ../../src/xcb_io.c:178: dequeue_pending_request: Assertion “Ixcb_xlib_unknown_req_in_deq' failed.
Aborted

Associated revisions

Revision d18529fc - 2012-05-16 04:23 PM - Alexander Bruy

show warning before updating exisiting shapefile (fix #5335)

Revision 52a35edd - 2012-05-17 09:06 PM - Alexander Bruy

show warning before updating exisiting shapefile (fix #5335)

History

#1 - 2012-04-09 07:41 AM - Giovanni Manghi

- Subject changed from "export/add geomtery columns" make QGIS crash if columns do already exist to "export/add geomtery columns" make QGIS
crash if columns (area, perimeter,coordx,corrdy,etc.) do already exist

#2 - 2012-04-09 08:45 AM - Alexander Bruy

Tested under 32-bit Slackware and QGIS master commit:d1a11bec96 and it works fine with both options (create new layer and update existing layer).

Maybe it crashes when this fields created by user and have different data type?

#3 - 2012-04-09 08:47 AM - Giovanni Manghi
Alexander Bruy wrote:

Maybe it crashes when this fields created by user and have different data type?

no, it crashes when using the tool two times in a row. | will attach here sample data that is causing the crash on both windows and ubuntu with

qgis-master.

#4 - 2012-04-09 09:24 AM - Giovanni Manghi

Giovanni Manghi wrote:

Alexander Bruy wrote:

Maybe it crashes when this fields created by user and have different data type?

no, it crashes when using the tool two times in a row. | will attach here sample data that is causing the crash on both windows and ubuntu with

qgis-master.

this is weird. | got the crash consistently for many tries while trying to find a pattern, then suddenly it stopped crashing (using the very same vectors)...

#5 - 2012-04-09 09:29 AM - Giovanni Manghi

Giovanni Manghi wrote:

Giovanni Manghi wrote:

Alexander Bruy wrote:

Maybe it crashes when this fields created by user and have different data type?

no, it crashes when using the tool two times in a row. | will attach here sample data that is causing the crash on both windows and ubuntu with

qgis-master.

this is weird. | got the crash consistently for many tries while trying to find a pattern, then suddenly it stopped crashing (using the very same

vectors)...

but still pretty easy to replicate... | tested other vectors and is enough to run two times in a row (after clicking "close" after the first time), regardless of the

vector used. | have also vector that cause qgis to crash the first time the tool is run.

#6 - 2012-04-09 09:34 AM - Alexander Bruy

Weird, still works for me. | tried several times with different vectors.

#7 - 2012-04-09 12:43 PM - Salvatore Larosa

Alexander Bruy wrote:
Weird, still works for me. | tried several times with different vectors.

The same for me, no problem!

#8 - 2012-04-09 01:31 PM - Salvatore Larosa

| did some tests in more detail and | noticed that sometimes QGIS crashes!
It is very difficult to reproduce!

When it crashes | get this:

$ agis

Warning: QObject::setParent: Cannot set parent, new parent is in a different thread
Warning: QObject::setParent: Cannot set parent, new parent is in a different thread
Warning: QPixmap: It is not safe to use pixmaps outside the GUI thread

Warning: QPixmap: It is not safe to use pixmaps outside the GUI thread

Warning: QPixmap: It is not safe to use pixmaps outside the GUI thread

Warning: QApplication: Object event filter cannot be in a different thread.

Warning: QPixmap: It is not safe to use pixmaps outside the GUI thread

Warning: QPixmap: It is not safe to use pixmaps outside the GUI thread

Warning: QPixmap: It is not safe to use pixmaps outside the GUI thread

Warning: QPixmap: It is not safe to use pixmaps outside the GUI thread

Warning: QPixmap: It is not safe to use pixmaps outside the GUI thread

Warning: QPixmap: It is not safe to use pixmaps outside the GUI thread
Segmentation fault

#9 - 2012-04-10 02:30 AM - Giovanni Manghi

Salvatore Larosa wrote:

| did some tests in more detail and | noticed that sometimes QGIS crashes!

It is very difficult to reproduce!

When it crashes | get this:

[]

it is really puzzling, but not that hard to replicate, at least on my Ubuntu machine with qgis-master installed with the nightly-build repo (and regardless of the
vector used). The errors are the one already posted.

#10 - 2012-04-29 10:18 AM - Salvatore Larosa

Is it still confirmed after Alexander's commit (commit:d3a50e8bcb)?

| cannot seem to reproduce it!
#11 - 2012-05-01 12:48 AM - Alexander Bruy

- Assignee deleted (cfarmer -)

- Status changed from Open to Feedback

#12 - 2012-05-02 05:19 AM - Giovanni Manghi
- Status changed from Feedback to Open

Hi Alexander, the feedback is that I'm still able to get the crash consistently (but not always) on both Linux and Windows.

#13 - 2012-05-02 09:52 AM - Salvatore Larosa

Now, | am able to reproduce!!
Apparently, it occurs if before opens attribute table (very strange!)!

For reproduce:

Load layer;

Open Attribute table;

run Export/add geometry column (fTools)

Crashes!

| am investigating!

#14 - 2012-05-02 11:17 AM - Alexander Bruy

Maybe I'm wrong but this is because QGIS don't support simultaneous access to one datasource from different threads

#15 - 2012-05-02 02:42 PM - Salvatore Larosa

- Subject changed from "export/add geomtery columns" make QGIS crash if columns (area, perimeter,coordx,corrdy,etc.) do already exist to "export/add

geomtery columns" make QGIS crash if you have previously opened the attribute table

It also occurs if the columns do not exist!

#16 - 2012-05-02 03:32 PM - Salvatore Larosa

if "save to new shapefile" is flagged, works fine!

Alexander, you're probably right!

#17 - 2012-05-03 02:31 AM - Salvatore Larosa
Alexander, | confirm, you're right!
Seems you can not access the same datasource from different threads simultaneously!!

That also occurs with Simplify Geometries tool!

one solution possible is:
| edited fTools (doGeometry.py and ui_frmGeometry.py) to avoid the issue by adding constraint to save a new file, as occurs in other tools!

2024-03-13 4/5



#18 - 2012-05-03 05:05 AM - Alexander Bruy
- Assignee set to Alexander Bruy

| think remove this functionality is not good solution. Maybe it is better to add warning before processing. Giovanni what do you think?

#19 - 2012-05-03 05:29 AM - Jiirgen Fischer

- Subject changed from "export/add geomtery columns" make QGIS crash if you have previously opened the attribute table to "export/add geometry

columns" make QGIS crash if you have previously opened the attribute table

#20 - 2012-05-03 05:38 AM - Giovanni Manghi

Alexander Bruy wrote:

I think remove this functionality is not good solution. Maybe it is better to add warning before processing. Giovanni what do you think?

running ftools and have the results computed in the input layer instead of a new shapefile seems to be a need of most common users, so | would like to

keep this option. The warning seems ok to me.

#21 - 2012-05-16 07:32 AM - Alexander Bruy
- Status changed from Open to Closed

Fixed in changeset commit:"d18529fc266cf03992a35244164b73e04e505a0e".

#22 - 2012-05-16 07:33 AM - Alexander Bruy

- Resolution set to fixed

#23 - 2017-05-01 01:22 AM - Giovanni Manghi

The "ftools" category is being removed from the tracker, changing the category of this ticket to "Processing/QGIS" to not leave the category orphaned.
